=== release@v0.7.0/cmd/kubepkg/templates/latest/deb/kubectl/debian/changelog ===
kubectl ({{ .Version }}-{{ .Revision }}) {{ .Channel }}; urgency=medium

  * https://git.k8s.io/kubernetes/CHANGELOG/README.md

 -- Kubernetes Authors <kubernetes-dev@googlegroups.com>  {{ date }}
