=== release@v0.7.0/cmd/kubepkg/templates/latest/deb/kubernetes-cni/debian/changelog ===
kubernetes-cni ({{ .Version }}-{{ .Revision }}) {{ .Channel }}; urgency=medium

  * https://git.k8s.io/kubernetes/CHANGELOG/README.md

 -- Kubernetes Authors <kubernetes-dev@googlegroups.com>  {{ date }}
