=== release@v0.7.0/cmd/kubepkg/templates/latest/deb/cri-tools/debian/control ===
Source: cri-tools
Section: misc
Priority: optional
Maintainer: Kubernetes Authors <kubernetes-dev@googlegroups.com>
Build-Depends: curl, ca-certificates, debhelper (>= 8.0.0)
Standards-Version: 3.9.4
Homepage: https://kubernetes.io
Vcs-Git: https://github.com/kubernetes-sigs/cri-tools.git
Vcs-Browser: https://github.com/kubernetes-sigs/cri-tools/

Package: cri-tools
Architecture: {{ .BuildArch }}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Container Runtime Interface Tools
 Binaries that interact with the container runtime through the container runtime interface
