=== release@v0.7.0/cmd/kubepkg/templates/latest/deb/kubectl/debian/control ===
Source: kubectl
Section: misc
Priority: optional
Maintainer: Kubernetes Authors <kubernetes-dev+release@googlegroups.com>
Build-Depends: curl, ca-certificates, debhelper (>= 8.0.0)
Standards-Version: 3.9.4
Homepage: https://kubernetes.io
Vcs-Git: https://github.com/kubernetes/kubernetes.git
Vcs-Browser: https://github.com/kubernetes/kubernetes

Package: kubectl
Architecture: {{ .BuildArch }}
Depends: ${misc:Depends}
Description: Kubernetes Command Line Tool
 The Kubernetes command line tool for interacting with the Kubernetes API.
